__kernel void initScalar(__global float* scalar,
			 float4 minPos,
			 float4 size)
{
  uint gidX = get_global_id(0);
  uint gidY = get_global_id(1);
  uint i;
  float2 pos, center=(float2)(0.5, 0.75);
  for(i=gidX; i<WIDTH; i+=WGN)
    {
      pos = (float2)(i*size.x, gidY*size.y);
      scalar[i+gidY*(WIDTH)] = ((distance(pos, center)<0.15) ? 1.0 : 0.0);
    }
}

#define PI (float)M_PI
__kernel void initVelocity(__global float* veloX,__global float* veloY,
		       //float t,
		       float4 minPos,
		       float4 size)
{
  uint gidX = get_global_id(0);
  uint gidY = get_global_id(1);
  uint i;
  float v;
  float time_term = 1.0;//cos(t*M_PI/3.0f);
  for(i=gidX; i<WIDTH; i+=WGN)
    {
      v = veloX[i+gidY*(WIDTH)] = -sin(i*size.x * PI)*sin(i*size.x * PI)*sin(gidY*size.y * PI * 2)*time_term;
      veloX[i+gidY*(WIDTH)] = v; // = Vx(x,y)
      veloY[i+gidY*(WIDTH)] = -v;// = Vy(y,x) = -Vx(x,y)
    }
}
