#configure_file(CTestCustom.ctest.in CTestCustom.ctest)
#add_test(NAME parmepy_test COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/BUILD_MAIN_PYTEST)
enable_testing()
find_python_module(pytest REQUIRED)

# ---  We create a new test for each test_XXX.py found in each directory (i.e. module) of parmepy ---

set(py_src_dirs
  fields
  particular_solvers
  domain
  integrator
  obstacle
  operator
  physics
  problem
  tools
  )

if(USE_MPI)
  set(py_src_dirs
    ${py_src_dirs} mpi)
endif()

foreach(testdir ${py_src_dirs})
  file(GLOB_RECURSE py_test_files "${test_dir}" RELATIVE_PATH parmepy/*/test_*.py)
endforeach()

foreach(testfile ${py_test_files})
  get_filename_component(testName ${testfile} NAME_WE)
  message(STATUS "Add test ${testName} ...")
  add_test(${testName} py.test -v ${testfile})
endforeach()

#add_test(NAME topology COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 py.test -v ${CMAKE_SOURCE_DIR}/parmepy/mpi/tests/test_topology.py)
# add_test(NAME topology COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 1 py.test -v ${CMAKE_SOURCE_DIR}/parmepy/mpi/tests/test_topology.py)
#  add_test(topology py.test -v ${CMAKE_SOURCE_DIR}/parmepy/mpi/tests/test_topology.py)



 