"""
@package parmepy.constants

Constant parameters required for the parmepy package (internal use).

"""
from parmepy import __DEBUG__
import numpy as np
import math
import mpi4py.MPI as MPI
import os

PI = math.pi
# Set default type for real and integer numbers
PARMES_REAL = np.float64
# type for array indices
PARMES_INDEX = np.uint32
# type for integers
PARMES_INTEGER = np.int64
## default array layout (fortran or C convention)
ORDER = 'F'
ORDERMPI = MPI.ORDER_F
DEBUG = 0
## label for x direction
XDIR = 0
## label for y direction
YDIR = 1
## label for z direction
ZDIR = 2
## Tag for periodic boundary conditions
PERIODIC = 0
## Directions string
S_DIR = ["_X", "_Y", "_Z"]


if __DEBUG__:
#define debug decorator:
    def debugdecorator(f):
        ## function f is being decorated
        def decorator(*args, **kw):
            # Print informations on decorated function
            if f.__name__ is '__new__':
                fullclassname = args[0].__mro__[0].__module__ + '.'
                fullclassname += args[0].__mro__[0].__name__
                print 'Instanciate :', fullclassname,
                print ' (Inherits from : ',
                print [c.__name__ for c in args[0].__mro__[1:]], ')'
            else:
                print 'Call : ', f.__name__, 'of ', f.__module__
            ## Calling f
            r = f(*args, **kw)
            if f.__name__ is '__new__':
                print '       |-> : ', repr(r)
            return r
        return decorator
else:
#define empty debug decorator:
    def debugdecorator(f):
        return f
debug = debugdecorator
