"""@package parmepy.domain.domain

Classes for physical domains description.
"""
from abc import ABCMeta, abstractmethod
from parmepy.constants import debug


class Domain(object):
    """Abstract description of physical domain. """

    __metaclass__ = ABCMeta

    @debug
    def __new__(cls, *args, **kw):
        return object.__new__(cls, *args, **kw)

    @debug
    @abstractmethod
    def __init__(self, dimension):
        """ Constructor
        @param dimension integer : domain dimension.
        """
        ## Domain dimension.
        self.dimension = dimension
        ## Domain topologies
        self.topologies = []

    @debug
    def addTopology(self, topo):
        try:
            idTopo = self.topologies.index(topo)
            del topo
        except ValueError:
            idTopo = len(self.topologies)
            self.topologies.insert(idTopo, topo)
            topo.setUp()
        return idTopo, self.topologies[idTopo]


if __name__ == "__main__":
    print __doc__
    print "- Provided class : Domain (abstract)."
    print Domain.__doc__

