"""@package parmepy.domain.obstacle

Classes for physical obstacle description.
"""
from abc import ABCMeta, abstractmethod


class Obstacle:
    """Abstract description of physical obstacle. """

    __metaclass__ = ABCMeta

    @abstractmethod
    def __init__(self, domain):
        """ Constructor
        @param domain : domain.
        """
        ## Domain.
        self.domain = domain
        ## Obstacle dimension.
        self.dimension = domain.dimension
        ## Geometrical definition of the obstacle
        self.definedObst = None


if __name__ == "__main__":
    print __doc__
    print "- Provided class : Obstacle (abstract)."
    print Obstacle.__doc__

