"""
Testing parmepy.domain.box.Box
"""
import parmepy as pp
from parmepy.constants import np


def test_create_box1():
    """Test default parameters"""
    dom = pp.box.Box()
    assert dom.dimension == 3
    assert np.allclose(dom.length, np.ones_like(dom.length))
    assert np.allclose(dom.origin, np.zeros_like(dom.origin))
    assert [b == pp.PERIODIC for b in dom.boundaries]


def test_create_box2():
    """Test given parameters"""
    L = np.asarray([1., 2.5])
    ori = np.asarray([1, 2.1])
    dom = pp.box.Box(2, length=L, origin=ori)
    assert dom.dimension == 2
    assert np.allclose(dom.length, L)
    assert np.allclose(dom.origin, ori)
    assert [b == pp.PERIODIC for b in dom.boundaries]

