"""
@package parmepy.fields.gpuscalar

Discrete variable scalar description for GPU.
@todo missing tests
"""
from parmepy.constants import np, ORDER, PARMES_REAL
from parmepy.fields.discrete import DiscreteField


class GPUScalarField(DiscreteField, GPUDiscreteField):
    """
    A scalar field, defined on each grid of each
    subdomain of the given topology.

    """

    def __init__(self, *args, **kwargs):
        """Constructor for a scalar field"""
        super(GPUScalarField, self).__init__(self, *args, **kwargs)
        self.vector = False
        self.data = np.zeros((self.resolution), dtype=PARMES_REAL, order=ORDER)

    def __str__(self):
        """ Display class information. """
        s = '[' + str(self.topology.rank) + '] '
        s += " id " + str(self.__idFromParent) + ", "
        s += self.name + " " + str(self.dimension)
        s += 'D gpu discrete field with resolution '
        s += str(self.data.shape) + "."
        return s + "\n"


if __name__ == "__main__":
    print __doc__
    print "- Provided class : Scalar"
    print ScalarField.__doc__
