"""
@package parmepy.fields.gpuvector

Discrete variable scalar description fot GPU.
@todo missing test
"""
from parmepy.constants import np, ORDER, PARMES_REAL
from parmepy.fields.discrete import DiscreteField


class VectorField(DiscreteField):
    """
    A vector field, defined on each grid of each subdomain
    of the given topology.
    Vector field is composed of several ScalarFields
    """

    def __init__(self, *args, **kwargs):
        """Constructor for a vector field"""
        super(VectorField, self).__init__(self, *args, **kwargs)
        self.data = [np.zeros((self.resolution),
                              dtype=PARMES_REAL, order=ORDER)
                     for d in xrange(self.dimension)]
        self.vector = True

    def __str__(self):
        """ Display class information """
        s = '[' + str(self.topology.rank) + '] '
        s += " id " + str(self.__idFromParent) + ", "
        s += self.name + " " + str(self.dimension)
        s += 'D gpu discrete vector field with resolution '
        s += str([data.shape for data in self.data]) + "."
        return s + "\n"


if __name__ == "__main__":
    print __doc__
    print "- Provided class : VectorField"
    print ScalarField.__doc__
