/**
 * M4prime weights.
 *
 * @param y Distance between the particle and left-hand grid point
 * @param s Scalar of the particle
 *
 * @return weights
 */
inline float alpha(float y, float s){
  return ((y * (y * (-y + 2.0) - 1.0)) / 2.0) * s;}
inline float beta(float y, float s){
  return ((y * y * (3.0 * y - 5.0) + 2.0) / 2.0) * s;}
inline float gamma(float y, float s){
  return ((y * (y * (-3.0 * y + 4.0) + 1.0)) / 2.0) * s;}
inline float delta(float y, float s){
  return ((y * y * (y - 1.0)) / 2.0) * s;}
