import parmepy as pp


## @pytest.fixture
## def topology():
##     import parmepy.mpi.topology as pptopo
##     import parmepy as pp
##     #dom = pp.Box()
##     return resolTopo


def test_create_topology1D():
    dom = pp.Box()
    resolTopo = [33, 33, 17]
    topo = pp.topology.Cartesian(dom, 1, resolTopo)

    assert topo.domain == dom
    assert topo.dim == 1
    assert topo.size == pp.mpi.main_size
    print topo


def test_create_topology2D():
    dom = pp.Box()
    resolTopo = [33, 33, 17]
    topo = pp.topology.Cartesian(dom, 2, resolTopo)

    assert topo.domain == dom
    assert topo.dim == 2
    assert topo.size == pp.mpi.main_size


def test_create_topology3D():
    dom = pp.Box()
    resolTopo = [33, 33, 17]
    topo = pp.topology.Cartesian(dom, 3, resolTopo)

    assert topo.domain == dom
    assert topo.dim == 3
    assert topo.size == pp.mpi.main_size


def test_create_topology_with_dims():
    dom = pp.Box()
    resolTopo = [33, 33, 17]
    topoDims = [pp.mpi.main_size, 1]
    topo = pp.topology.Cartesian.withResolution(dom, topoDims, resolTopo)

    assert topo.domain == dom
    assert topo.dim == 2
    assert topo.size == pp.mpi.main_size
    testList = topo.dims == topoDims
    assert testList.all()


def test_comparing_topologies():
    dom = pp.Box()
    resolTopo = [33, 33, 17]
    topoDims = [pp.mpi.main_size, 1]
    topo = pp.topology.Cartesian.withResolution(dom, topoDims, resolTopo)
    topo2 = pp.topology.Cartesian(pp.Box(), 2, resolTopo)
    assert not topo == topo2
    topo2 = pp.topology.Cartesian(dom, 2, [11, 33, 17])
    assert not topo == topo2

if __name__ == "__main__":

    #test_create_topology1D()
    #pp.mpi.main_comm.barrier()

    test_create_topology2D()
    pp.mpi.main_comm.barrier()
