"""
@package parmepy.numerics.method

Numerical method interface.
"""
from abc import ABCMeta, abstractmethod
from parmepy.constants import debug


class NumMethod(object):
    """Abstract description of numerical method. """

    __metaclass__ = ABCMeta

    @debug
    def __new__(cls, *args, **kw):
        return object.__new__(cls, *args, **kw)

    @debug
    @abstractmethod
    def __init__(self):
        """ Creates a numerical method."""
        self.name = ''

    @debug
    @abstractmethod
    def __call__(self):
        """Call the method"""
        pass
