"""
Testing parmepy.operator.particle_advection
"""
from parmepy.domain.box import Box
from parmepy.fields.analytical import AnalyticalField
from parmepy.operator.advection import Advection
import pytest


def test_null_velocity():
    dom = Box(dimension=2, origin=[0., 0.], length=[1., 1.])
    resolTopo = [33, 33]
    csf = AnalyticalField(dom, formula=lambda x, y: 1.)
    cvf = AnalyticalField(dom, vector=True, formula=lambda x, y: (0., 0.))
    advec = Advection(cvf, csf)
    advec.setUp(resolutions={csf: [33, 33],
                             cvf: [33, 33]},
                method='')
    pytest.raises(ValueError, advec.apply, 0., 1., 1)
#    advec.apply(0., 1., 1)

