"""
@package parmepy.problem.navier_stokes
"""
from parmepy.problem.problem import Problem
from parmepy.operator.advection import Advection
from parmepy.operator.stretching import Stretching
from parmepy.operator.poisson import Poisson
from parmepy.operator.diffusion import Diffusion
from parmepy.operator.penalization import Penalization


class NSProblem(Problem):
    """
    Navier Stokes problem description.
    """
    def __init__(self, operators=[], monitors=[]):
        Problem.__init__(self, operators, monitors)
        for op in operators:
            if isinstance(op, Advection):
                self.advection = op
            if isinstance(op, Stretching):
                self.stretch = op
            if isinstance(op, Diffusion):
                self.diffusion = op
            if isinstance(op, Poisson):
                self.poisson = op
            if isinstance(op, Penalization):
                self.penal = op

#    def setUp(self, t_end, dt,
#              advection_config=None,
#              stretch_config=None,
#              diffusion_config=None,
#              poisson_config=None,
#              penal_config=None):
##        if velocity_config is None and self.velocity is not None:
##            raise ValueError("A configuration for velocity operator" +
##                             " is required")
#        Problem.setUp(self, t_end, dt)
#        if self.advection is not None:
#            self.advection.setUp(**advection_config)
#        if self.stretch is not None:
#            self.stretch.setUp(**stretch_config)
#        if self.diffusion is not None:
#            self.diffusion.setUp(**diffusion_config)
#        if self.poisson is not None:
#            self.poisson.setUp(**poisson_config)
#        if self.penal is not None:
#            self.penal.setUp(**penal_config)
#        self._collect_topologies()
